-------------------------------------------------------------- 
--  Subject : Conversion to a string
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

  function ConvToStr( InitA )
    if Null( InitA ) then
      S := 'NIL'
    else
      S := ''
      Stack << [ == InitA, << Stack ]     -- Push an alias
                                          -- to chain stack

      ---- Postorder traversal ----

      while not Null( Stack ) do
        A == Stack[ 1 ]                   -- Pop an alias
  
        Temp << Stack[ 2 ]                -- Remove a head  
        Destroy( Stack )                  -- of the chain stack
        Stack << Temp  
  
        ClassA := ClassOf( A )

        if Inheritor( A, [] ) then
          Stack << [ ==']', << Stack ]  -- Push an alias of ']' to Stack
          K := Card( A )
          for I:=1 to K do
            if I > 1 then
              Stack << [ ==',', << Stack ]  
            end
            Stack << [ == A[ K - I + 1 ], << Stack ]
          end
          Stack << [ =='[', << Stack ]
        else
          Destroy( R )
          if    ClassA = ClassOf( '' ) then
            R := A
          elsif ( ClassA = ClassInteger ) or ( ClassA = ClassReal ) then
            R := STR( A )
          else
            R := 'NIL'
          end 
          S := S + R
        end
      end
    end
  return S

return
