-------------------------------------------------------------- 
--  Subject : Exceptions
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

A := [ 67, 56.4, 'abc', *, *, 9 ]

try
  for I:=1 to Card( A ) do
    if Null( A[ I ] ) then 
      raise Break    
    end
  end
except
  writeln( I )
end

try 
  raise 9 + 8
except
  on E : Integer do
    writeln( E )
  end
end

try  
  for I:=0 to Card( A ) do
    writeln( A[ I ] )
  end
except
  on ERangeError do  
    writeln( 'Range error' )
  end
end

try   
  for I:=0 to Card( A ) do
    writeln( A[ I ] )
  end
finally
  writeln( 'finally OK' )
end

return
