-------------------------------------------------------------- 
--  Subject : Text file processing
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

class TextFile
  function Assign( Name ) constructor
  function Reset() 
  function Rewrite()
  function Append() 
  function Close()
  function Readln()
  function Writeln( S ) 
  function EOF() 
end

implementation TextFile
  local Handle
  function Assign( Name ) external
  function Reset() external
  function Rewrite() external
  function Append() external
  function Close() external
  function Readln() external
  function Writeln( S ) external
  function EOF() external         
end

object F( 'temp.w' ), G( 'temp' ) : TextFile

F.Reset()
G.Rewrite()

while not F.EOF() do
  S := F.Readln()
  Writeln( S )

  G.Writeln( S )
end

F.Close()
G.Close()

return
